<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_speventum
 *
 * @copyright   Copyright (C) 2010 - 2021 JoomShaper. All rights reserved.
 * @license     GNU General Public License version 2 or later.
 */

// No direct access
defined ('_JEXEC') or die ('Restricted access');

use Joomla\CMS\Factory;
use Joomla\CMS\MVC\View\HtmlView;
use Joomla\CMS\Component\ComponentHelper;

class SpeventumViewSchedules extends HtmlView
{

    protected $items; 
	protected $pagination;

    public function display($tpl = null)
    {
        $model 			= $this->getModel();
		$this->items		= $this->get('Items');
		$this->pagination	= $this->get('Pagination');
		$this->cParams 			= ComponentHelper::getParams('com_speventum');

		$app 	= Factory::getApplication();
		$this->params = $app->getMenu()->getActive()->getParams(); 

        foreach ($this->items as $key => $this->item) {
			$sessions = $model->getSessions($this->item->id);
			$this->item->sessions = $sessions;
			
			if(count($this->item->sessions)) {
				foreach ($this->item->sessions as $session) {
					$session->speakers = $model->getSpeakers($session->speakers);
				}
			}
		}

        return parent::display($tpl = null);
    }
}
    
