<?php
/**
 * @package     Joomla.Site
 * @subpackage  com_speventum
 *
 * @copyright   Copyright (C) 2010 - 2021 JoomShaper. All rights reserved.
 * @license     GNU General Public License version 2 or later.
 */

// No direct access
defined ('_JEXEC') or die ('Restricted access');

?>
<div id="sp-com-eventum" class="sp-com-eventum sp-eventum-view-speaker">
	<div class="row">
		<div class="col-sm-5">
			<img src="<?php echo $this->speaker->image; ?>" alt="<?php echo $this->speaker->title; ?>">
		</div>

		<div class="col-sm-7">

			<h2 class="speaker-title"><?php echo $this->speaker->title; ?></h2>
			<p class="lead speaker-designation"><?php echo $this->speaker->designation; ?></p>

			<?php if(isset($this->speaker->url) && $this->speaker->url) { ?>
			<p class="speaker-website"><a target="_blank" href="<?php echo $this->speaker->url; ?>"><?php echo $this->speaker->url; ?></a></p>
			<?php } ?>

			<?php if(count($this->speaker->socials)) { ?>
			<div class="speaker-social-icons">
				<ul>
				<?php foreach ($this->speaker->socials as $key => $social) { ?>
					<li>
						<a target="_blank" class="social-<?php echo $social[0]; ?>" href="<?php echo $social[1]; ?>"><i class="fab fa-<?php echo $social[0]; ?>"></i></a>
					</li>
				<?php } ?>
				</ul>
			</div>
			<?php } ?>

			<div class="speaker-description">
				<?php echo $this->speaker->description; ?>
			</div>
		</div>
	</div>
</div>
