<?php
/**
* @package SP Page Builder
* @author JoomShaper http://www.joomshaper.com
* @copyright Copyright (c) 2010 - 2018 JoomShaper
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
*/
//no direct accees
defined ('_JEXEC') or die ('Restricted access');

use Joomla\CMS\Language\Text;

SpAddonsConfig::addonConfig(
	[
		'type' => 'content',
		'addon_name' => 'sp_countdown',
		'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN'),
		'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_DESC'),
		'category' => 'Eventum',
		'settings' => [
			'general' => [
				'title' => Text::_('COM_SPPAGEBUILDER_ADDON_ADMIN_LABEL'),
				'fields' => [
					'admin_label' => [
						'type' => 'text',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_ADMIN_LABEL'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_ADMIN_LABEL_DESC'),
						'std' => ''
					],
					'title' => [
						'type' => 'text',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_DESC'),
						'std' =>   'BUSINESS CONFERENCE 2025'
					],
					'heading_selector' => [
						'type' => 'headings',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_HEADINGS'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_HEADINGS_DESC'),
						'std'=>'h3',
						'depends' => [['title', '!=', '']],
					],
					'title_typography' => [
						'type' => 'typography',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_TYPOGRAPHY'),
						'depends' => [['title', '!=', '']],
						'fallbacks'   => [
							'font' => 'title_font_family',
							'size' => 'title_fontsize',
							'line_height' => 'title_lineheight',
							'letter_spacing' => 'title_letterspace',
							'uppercase'      => 'title_font_style.uppercase',
							'italic'         => 'title_font_style.italic',
							'underline'      => 'title_font_style.underline',
							'weight'         => 'title_font_style.weight',
						],
					],
					'title_text_color' => [
						'type' => 'color',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_TEXT_COLOR'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_TEXT_COLOR_DESC'),
						'depends' => [['title', '!=', '']],
					],
					'title_margin_top' => [
						'type' => 'slider',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_MARGIN_TOP'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_MARGIN_TOP_DESC'),
						'placeholder' => '10',
						'max' => 500,
						'responsive' => true,
						'depends' => [['title', '!=', '']],
					],
					'title_margin_bottom' => [
						'type' => 'slider',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_MARGIN_BOTTOM'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_MARGIN_BOTTOM_DESC'),
						'placeholder' => '10',
						'max' => 500,
						'responsive' => true,
						'depends' => [['title', '!=', '']],
					],
					'subtitle' => [
						'type'=>'text',
						'title'=>Text::_('COM_SPPAGEBUILDER_ADDON_SUBTITLE'),
						'desc'=>Text::_('COM_SPPAGEBUILDER_ADDON_SUBTITLE_DESC'),
						'std'=>  '18 - 21 DECEMBER, 2025, DUBLIN'
					],
					'subtitle_typography' => [
						'type' => 'typography',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_TYPOGRAPHY'),
						'depends' => [['title', '!=', '']],
						'fallbacks'   => [],
					],
					'subtitle_text_color' => [
						'type' => 'color',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_TEXT_COLOR'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_TITLE_TEXT_COLOR_DESC'),
						'depends' => [['title', '!=', '']],
					],
				]
			],
			'countdown_options' => [
				'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_OPTIONS'),
				'fields' => [
					'date' => [
						'type' => 'text',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_DATE'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_DATE_DESC'),
						'placeholder' => '2019/12/25',
						'std' => '2025/12/25'
					],
					'time' => [
						'type' => 'text',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_TIME'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_TIME_DESC'),
						'placeholder' => '20:23',
						'std' =>  '20:23',
					],
					'finish_text' => [
						'type' => 'text',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_FINISHED_TEXT'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_FINISHED_TEXT_DESC'),
						'placeholder' => 'Finally we are here',
						'std' =>  'Finally we are here',
					],
					'counter_height' => [
						'type' => 'slider',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_COUNTER_HEIGHT'),
						'placeholder' => '',
						'max' => 500,
						'responsive' => true,
						'std' =>  ['md' => 80]
					],
					'counter_width' => [
						'type' => 'slider',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_COUNTER_WIDTH'),
						'placeholder' => '',
						'max' => 500,
						'responsive' => true,
						'std' =>  ['md' => 8]
					],
					'counter_font_size' => [
						'type' => 'slider',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_COUNTER_FONT_SIZE'),
						'std' =>  ['md' => 48],
						'max' => 500,
						'responsive' => true
					],
					'counter_typography' => [
						'type' => 'typography',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_TYPOGRAPHY'),
						'depends' => [],
						'fallbacks'   => [
							'size' => 'counter_font_size',
						],
					],
					'counter_text_color' => [
						'type' => 'color',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_COUNTER_TEXT_COLOR'),
						'std' => '#FFFFFF',
					],
					'counter_background_color' => [
						'type' => 'color',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_COUNTER_BACKGROUND_COLOR'),
						'std' => '#0089e6',
					],
					'counter_user_border' => [
						'type' => 'checkbox',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_USE_BORDER'),
						'std' => 0
					],
					'counter_border_width' => [
						'type' => 'slider',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_WIDTH'),
						'std' => ['md' => 1],
						'depends' => ['counter_user_border' => 1],
						'max' => 500,
						'responsive' => true
					],
					'counter_border_color' => [
						'type' => 'color',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_COLOR'),
						'std' => '#E5E5E5',
						'depends' => ['counter_user_border' => 1]
					],
					'counter_border_style' => [
						'type' => 'select',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_STYLE'),
						'values' => [
							'none' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_STYLE_NONE'),
							'solid' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_STYLE_SOLID'),
							'double' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_STYLE_DOUBLE'),
							'dotted' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_STYLE_DOTTED'),
							'dashed' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_STYLE_DASHED'),
						],
						'std' => 'solid',
						'depends' => ['counter_user_border' => 1]
					],
					'counter_border_radius' => [
						'type' => 'slider',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_BORDER_RADIUS'),
						'std' => ['md' => 4],
						'max' => 500,
						'responsive' => true
					],
					'label_typography' => [
						'type' => 'typography',
						'title' => Text::_('COM_SPPAGEBUILDER_GLOBAL_TYPOGRAPHY'),
						'depends' => [],
						'fallbacks'   => [
							'font' => 'label_font_familly',
							'size' => 'label_font_size',
							'line_height' => 'label_font_height',
							'letter_spacing' => 'label_font_letterspace',
							'uppercase'      => 'label_font_style.uppercase',
							'italic'         => 'label_font_style.italic',
							'underline'      => 'label_font_style.underline',
							'weight'         => 'label_font_style.weight',
						],
					],
					'label_color' => [
						'type' => 'color',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_COUTNDOWN_COUNTER_LABEL_COLOR'),
						'std' => '',
					],
					'class' => [
						'type' => 'text',
						'title' => Text::_('COM_SPPAGEBUILDER_ADDON_CLASS'),
						'desc' => Text::_('COM_SPPAGEBUILDER_ADDON_CLASS_DESC'),
						'std' =>  ''
					],
				]
			]
		],
	]
);