<?php
/**
 * @package SP Page Builder
 * @author JoomShaper http://www.joomshaper.com
 * @copyright Copyright (c) 2010 - 2018 JoomShaper
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
*/
//no direct accees
defined ('_JEXEC') or die ('Restricted access');

class SppagebuilderAddonCountdown extends SppagebuilderAddons {

	public function render() {
		// Options
		$class 	 			= (isset($this->addon->settings->class) && $this->addon->settings->class) ? ' ' . $this->addon->settings->class : '';
		$title 				= (isset($this->addon->settings->title) && $this->addon->settings->title) ? $this->addon->settings->title : '';
		$heading_selector 	= (isset($this->addon->settings->heading_selector) && $this->addon->settings->heading_selector) ? $this->addon->settings->heading_selector : 'h3';
		$subtitle = (isset($this->addon->settings->subtitle) && $this->addon->settings->subtitle) ? $this->addon->settings->subtitle : '';

		$output  = '';
		$output .= '<div class="sppb-addon event-countdown sppb-addon-countdown ' . $class . '">';
		$output .= "<div id='countdown-timer' class='sppb-countdown-timer sppb-row'></div>";
		$output .= '<div class="countdown-text-wrap">';
		$output .= ($title) ? '<'.$heading_selector.' class="sppb-addon-title countdown-timer-title">' . $title . '</'.$heading_selector.'>' : '';
		$output .= '<h3 class="countdown-timer-subtitle">' . $subtitle . '</h3>';
		$output .= '</div>';
		$output .= '</div>';
		return $output;
	}

	public function scripts() {
		return array(JURI::base(true) . '/components/com_sppagebuilder/assets/js/jquery.countdown.min.js');
	}

	public function js() {
		$date 		  			= JHtml::_('date', $this->addon->settings->date, 'Y/m/d');
		$time 		  			= $this->addon->settings->time;
		$finish_text 			= addslashes($this->addon->settings->finish_text);
		$js = "
		jQuery(function($){
			var addon_id = '#sppb-addon-'+'".$this->addon->id."';
			$( addon_id +' .sppb-addon-countdown .sppb-countdown-timer').each(function () {
					var cdDateFormate = '".$date."' + ' ' + '".$time."';
					$(this).countdown(cdDateFormate, function (event) {
							$(this).html(event.strftime('<div class=\"sppb-countdown-days sppb-col-xs-6 sppb-col-sm-3\"><span class=\"sppb-countdown-number\">%-D</span><span class=\"sppb-countdown-text\">%!D: ' + '".JTEXT::_('COM_SPPAGEBUILDER_DAY')."' + ',' + '".JTEXT::_('COM_SPPAGEBUILDER_DAYS')."' + ';</span></div><div class=\"sppb-countdown-hours sppb-col-xs-6 sppb-col-sm-3\"><span class=\"sppb-countdown-number\">%H</span><span class=\"sppb-countdown-text\">%!H: ' + '".JTEXT::_('COM_SPPAGEBUILDER_HOUR')."' + ',' + '".JTEXT::_('COM_SPPAGEBUILDER_HOURS')."' + ';</span></div><div class=\"sppb-countdown-minutes sppb-col-xs-6 sppb-col-sm-3\"><span class=\"sppb-countdown-number\">%M</span><span class=\"sppb-countdown-text\">%!M:' + '".JTEXT::_('COM_SPPAGEBUILDER_MINUTE')."' + ',' + '".JTEXT::_('COM_SPPAGEBUILDER_MINUTES')."' + ';</span></div><div class=\"sppb-countdown-seconds sppb-col-xs-6 sppb-col-sm-3\"><span class=\"sppb-countdown-number\">%S</span><span class=\"sppb-countdown-text\">%!S:' + '".JTEXT::_('COM_SPPAGEBUILDER_SECOND')."' + ',' + '".JTEXT::_('COM_SPPAGEBUILDER_SECONDS')."' + ';</span></div>'))
							.on('finish.countdown', function () {
									$(this).html('<div class=\"sppb-countdown-finishedtext-wrap sppb-col-xs-12 sppb-col-sm-12\"><h3 class=\"sppb-countdown-finishedtext\">' + '".$finish_text."' + '</h3></div>');
							});
					});
			});
		})";
		return $js;
	}

	public function css() {
		$settings = $this->addon->settings;
		$addon_id = '#sppb-addon-' . $this->addon->id;
		$cssHelper = new CSSHelper($addon_id);
		$use_border = (isset($settings->counter_user_border) && $settings->counter_user_border) ? 1 : 0;
		
		$css = '';

		$counterStyleProps = [
			'counter_height' => ['height', 'line-height'],
			'counter_width' => 'width',
			'counter_text_color' => 'color',
			'counter_background_color' => 'background-color',
			'counter_border_radius' => 'border-radius',
		];

		$counterStyleUnites = [
			'counter_text_color' => false,
			'counter_background_color' => false
		];

		if ($use_border) {
			$borderStyleProps = [
				'counter_border_width' => 'border-width',
				'counter_border_style' => 'border-style',
				'counter_border_color' => 'border-color'
			];
			$counterBorderUnits = [
				"counter_border_style" => false,
				"counter_border_color" => false
			];
			$counterStyleProps = array_merge($counterStyleProps, $borderStyleProps);
			$counterStyleUnites = array_merge($counterStyleUnites, $counterBorderUnits);
		}
		$css .= $cssHelper->generateStyle(" .sppb-countdown-number", $settings, $counterStyleProps, $counterStyleUnites);
		$title_typography_fallback = [
			'font' => 'title_font_family',
			'size' => 'title_fontsize',
			'line_height' => 'title_lineheight',
			'letter_spacing' => 'title_font_style',
			'uppercase'      => 'title_font_style.uppercase',
			'italic'         => 'title_font_style.italic',
			'underline'      => 'title_font_style.underline',
			'weight'         => 'title_font_style.weight',
		];
		$css .= $cssHelper->typography(" .sppb-countdown-number", $settings, 'counter_typography', $title_typography_fallback);

		// label
		$labelStyleProps = [
			'label_color' => 'color',
		];

		$labelStyleUnites = [
			'label_color' => false,
		];
		$label_typography_fallback = [
			'font' => 'label_font_familly',
			'size' => 'label_font_size',
			'line_height' => 'label_font_height',
			'letter_spacing' => 'label_font_letterspace',
			'uppercase'      => 'label_font_style.uppercase',
			'italic'         => 'label_font_style.italic',
			'underline'      => 'label_font_style.underline',
			'weight'         => 'label_font_style.weight',
		];
		$css .= $cssHelper->typography(" .sppb-countdown-text", $settings, 'label_typography', $label_typography_fallback);
		$css .= $cssHelper->generateStyle(' .sppb-countdown-text', $settings, $labelStyleProps, $labelStyleUnites);
		
		$labelFallbacks = [
			'font' => 'label_font_family',
			'size' => 'label_font_size',
			'line_height' => 'title_lineheight',
			'letter_spacing' => 'title_letterspace',
			'uppercase'      => 'title_font_style.uppercase',
			'italic'         => 'title_font_style.italic',
			'underline'      => 'title_font_style.underline',
			'weight'         => 'title_font_style.weight',
		];

		$css .= $cssHelper->typography(" .sppb-countdown-text", $settings, 'label_typography', $labelFallbacks);

		// countdown-timer-subtitle
		$subtitleStyleProps = [
			'subtitle_text_color' => 'color'
		];
		$subtitleStyleUnites = [
			'subtitle_text_color' => false
		];
		$css .= $cssHelper->typography(" .countdown-timer-subtitle", $settings, 'subtitle_typography', []);
		$css .= $cssHelper->generateStyle(' .countdown-timer-subtitle', $settings, $subtitleStyleProps, $subtitleStyleUnites);

		return $css;
	}

	public static function getTemplate() {
		$lodash = new Lodash('#sppb-addon-{{ data.id }}');
		
		$output = '<style type="text/css">';
		
		$titleTypegraphyFallback = [
			'font'           => 'data.btn_font_family',
			'size'           => 'data.btn_fontsize',
			'letter_spacing' => 'data.btn_letterspace',
			'uppercase'      => 'data.btn_font_style?.uppercase',
			'italic'         => 'data.btn_font_style?.italic',
			'underline'      => 'data.btn_font_style?.underline',
			'weight'         => 'data.btn_font_style?.weight'
		];
		$output .= $lodash->typography('.sppb-addon-title.countdown-timer-title', 'data.title_typography', $titleTypegraphyFallback);
		$output .= $lodash->color('color', '.sppb-addon-title.countdown-timer-title', 'data.title_text_color');
		
		//subtitle
		$output .= $lodash->typography('.countdown-timer-subtitle', 'data.subtitle_typography', []);
		$output .= $lodash->color('color', '.countdown-timer-subtitle', 'data.subtitle_text_color');

		$counterStyleProps = [
			'counter_height' => ['height', 'line-height'],
			'counter_width' => 'width',
			'counter_text_color' => 'color',
			'counter_background_color' => 'background-color',
			'counter_border_radius' => 'border-radius',
		];

		$counterStyleUnites = [
			'counter_text_color' => false,
			'counter_background_color' => false,
		];

		$output .= $lodash->color('color' , '.sppb-countdown-number, .sppb-countdown-finishedtext', 'data.counter_text_color');
		$output .= $lodash->color('background-color' , '.sppb-countdown-number, .sppb-countdown-finishedtext', 'data.counter_background_color');
		$output .= '<# if ( data.counter_user_border ) { #>';
		$output .= $lodash->unit('border-width' , '.sppb-countdown-number, .sppb-countdown-finishedtext', 'data.counter_border_width', 'px');
		$output .= $lodash->unit('border-radius' , '.sppb-countdown-number, .sppb-countdown-finishedtext', 'data.counter_border_radius', 'px');
		$output .= $lodash->unit('border-style' , '.sppb-countdown-number, .sppb-countdown-finishedtext', 'data.counter_border_style');
		$output .= $lodash->unit('border-color' , '.sppb-countdown-number, .sppb-countdown-finishedtext', 'data.counter_border_color');
		$output .= '<# } #>';
		$output .= $lodash->unit('width' , '.sppb-countdown-number', 'data.counter_width', 'px');
		$output .= $lodash->unit('height' , '.sppb-countdown-number', 'data.counter_height', 'px');
		$output .= $lodash->typography('.sppb-countdown-number', 'data.counter_typography',  []);
		
		// label
		$output .= $lodash->color('color' , '.sppb-countdown-text', 'data.label_color');
		$labelTypegraphyFallback = [
			'font'           => 'data.btn_font_family',
			'size'           => 'data.btn_fontsize',
			'letter_spacing' => 'data.btn_letterspace',
			'uppercase'      => 'data.btn_font_style?.uppercase',
			'italic'         => 'data.btn_font_style?.italic',
			'underline'      => 'data.btn_font_style?.underline',
			'weight'         => 'data.btn_font_style?.weight'
		];
		$output .= $lodash->typography('.sppb-countdown-text', 'data.label_typography',  $labelTypegraphyFallback);

		$output .= '
		</style>
		<div class="sppb-addon event-countdown sppb-addon-countdown {{ data.class }}">
			<div id="countdown-timer" class="sppb-countdown-timer sppb-row" data-date="{{ data.date }}" data-time="{{ data.time }}" data-finish-text="{{ data.finish_text }}"></div>
			<div class="countdown-text-wrap">
				<# if ( !_.isEmpty( data.title ) ) { #>
					<{{ data.heading_selector }} 
						class="sppb-addon-title countdown-timer-title sp-inline-editable-element" 
						data-id={{data.id}} data-fieldName="title" contenteditable="true">
						{{ data.title }}
					</{{ data.heading_selector }}>
				<# } #>
				<# if ( !_.isEmpty( data.subtitle ) ) { #>
					<h3 class="countdown-timer-subtitle"> 
						{{{data.subtitle}}} 
					</h3>
				<# } #>
			</div>
		</div>
		';
		return $output;
	}

}
